% This function gives the solution of derivative of SDF wrt rho at rho=1
% and linear dynamics of consumption as
% x(t) = G*x(t-1)+H*w(t), wt follow std norm dist.
% c(t+1)-c(t) = mc + Uc*x(t)+lambda0*w(t+1)
% lambdab is the discounted response of consumption to shocks
% lambdab = lambda0+beta*Uc*inv(I-G)*H
% Ds1(t+1,t) = 1/2*w(t+1)'*Theta0*w(t+1)+w(t+1)'*Theta1*x(t)+theta0+theta1*x(t)+theta2*w(t+1)
% s1(t+1,t)  = ms + Us*x(t) + kesi0*w(t+1)

function [Theta0 Theta1 theta0 theta1 theta2] = DSDF1(G, H, lambdab, mv, Uv, Udv, Yd, beta, gamma)
Theta0 = (gamma-1)*H'*Yd*H;
Theta1 = (gamma-1)*H'*Yd*G;
theta0 = (1-gamma)^3/2*lambdab*H'*Yd*H*lambdab'+(1-gamma)^2*Udv*H*lambdab'+(1-gamma)/2*trace(H'*Yd*H)+(1-1/beta)*mv;
theta1 = (1-gamma)^2*lambdab*H'*Yd*G+Uv*(G-eye(size(G))/beta);
theta2 = (gamma-1)*Udv*H+Uv*H;