% This function give the recursion of pricing operator for general case when rou~=1
% It gives W1, w1 and k1 in: P(exp(-1/2*x'W0*x -w0*x-k0)) =exp(-1/2*x'W1*x-w1*x-k1) 
% x(t) = G*x(t-1)+H*w(t), wt follow std norm dist.
% d(t+1)-d(t) = md + Ud*x(t)+iota0*w(t+1) 
%             = md + pi*w_(t+1) - Ud*(I-G)^(-1)*(x_(t+1)-x(t))
% where pi = iota1
% s(t+1,t) = s1(t+1,t) + (rho-1)*Ds(t+1,t) 
%          =1/2*w(t+1)'*Theta0*w(t+1) + w(t+1)'*Theta1*x(t)
%           + ms + Us*x(t) + kesi0*w(t+1)

function [W1 w1 k1] = PRICEOPE(W0,w0,k0,G,H,Theta0,Theta1,ms, Us, kesi0,md,pi)
% calculate one step update of eigenfunction and eigenvalue
M      = Theta0 + H'*W0*H;
A      = Theta1 - H'*W0*G;
m0     = pi + kesi0 - w0*H;
tempM  = inv(eye(size(M))+M);
W1     = G'*W0*G - A'*tempM*A;
w1     = -(Us - w0*G) - (pi + kesi0-w0*H)*tempM*A;
k1     = k0 + md + ms + log(abs(det(tempM^0.5))) + 0.5*m0*tempM*m0';