% This function give the recursion of pricing operator when rou=1
% It gives w1 and k1 in: P(exp(w0*x+k0)) =exp(w1*x+k1) 
% x(t) = G*x(t-1)+H*e(t), et follow std norm dist.
% d(t+1)-d(t) = md + Ud*x(t)+iota0*e(t+1)
% s(t+1,t) = ms + Us*x(t) + kesi0*e(t+1) is SDF

function [w1 k1 wbar nu] = priceope1(w0,k0,G,H,Us,ms,kesi0,md,pi)
tempG  = inv(eye(size(G))-G);
% calculate one step update of eigenfunction and eigenvalue
w1     = w0*G + Us;
k1     = k0 + ms + md + (w0*H + kesi0 + pi)*(w0*H + kesi0 + pi)'/2;
wbar   = Us*tempG; % dominant eigenfunction
nu     = ms + md + (wbar*H + kesi0 + pi)*(wbar*H + kesi0 + pi)'/2; % dominant eigenvalue

