% This function calculate dominant eigenvalue and eigenfunction pricing operator for general case when rou~=1
% It gives Wbar, wbar and nv in: P(exp(-1/2*x'Wbar*x -wbar*x)) =exp(-1/2*x'Wbar*x-wbar*x)exp(-nv) 
% x(t) = G*x(t-1)+H*e(t), et follow std norm dist.
% d(t+1)-d(t) = md + Ud*x(t)+iota0*w(t+1)
%             = md + pi*w_(t+1) - Ud*inv(I-G)*(x_(t+1)-x(t))
% s(t+1,t) = s1(t+1,t) + (rho-1)*Ds(t+1,t) 
%          = 1/2e(t+1)'*Theta0rho*e(t+1)+e(t+1)'*Theta1rho*x(t)+msrho+Usrho*x(t)+kesi0rho*e(t+1)

function [Wbar wbar nu] = PRICEOPEBAR(G,H,Theta0,Theta1,ms,Us,kesi0,md,pi)
N      = size(G); % dimension of state vector
A      = G;
B      = -H;
E      = eye(N);
S      = Theta1';
R      = eye(size(Theta0))+Theta0;
Q      = zeros(N);
[Wbar, L, K] = dare(A,B,Q,R,S,E);
tempHK = inv(eye(N)-G-H*K);
tempM  = inv(eye(size(Theta0))+ Theta0 + H'*Wbar*H);
wbar   = -(Us + kesi0*K + pi*K)*tempHK; 
temppi = pi + kesi0-wbar*H;
nu     = -(md + ms + log(abs(det(tempM^0.5))) + 0.5*temppi*tempM*temppi'); % dominant eigenvalue