% This function give the long-run risk free rate and price of risk 
% It gives pistar and Pistar in: 
% nu + yita = rf + pistar*pi + 1/2*pi*PIstart*pi'
% x(t) = G*x(t-1)+H*w(t), wt follow std norm dist.
% s(t+1,t) = ms + Us*x(t) + kesi0*w(t+1) + w(t+1)'*Theta1*xt+1/2*w(t+1)'*Theta0*w(t+1)
% Note: rf, pistar and PIstar do not depend on (md, Ud and pi)
function [rf pistar PIstar] = RETOPE(G, H, W,w,Theta0, Theta1, ms, Us, kesi0)
% intermediate variables
M       = Theta0 + H'*W*H;
A       = Theta1 - H'*W*G;
tempM   = inv(eye(size(M)) + M);
K       = tempM*A;
Ghat    = K*inv(eye(size(G))-G-H*K)*H;
kesi1   = (kesi0 + (Us + kesi0*K)*inv(eye(size(G))-G-H*K)*H)';
% long-run risk free rate
rf      = -ms -0.5*log(abs(det(tempM)))-0.5*kesi1'*tempM*kesi1;
% long-run price  
tempG   = eye(size(Ghat)) + Ghat;
pistar  = - tempG*tempM*kesi1;
PIstar  = - tempG*tempM*tempG';