% This function gives the solution of SDF when rho not equal to 1 
% and linear dynamics of consumption as
% x(t) = G*x(t-1)+H*e(t), et follow std norm dist.
% c(t+1)-c(t) = mc + Uc*x(t)+gamma0*e(t+1)
% gammab is the discounted response of consumption to shocks
% gammab = gamma0+beta*Uc*inv(I-G)*H
% s(t+1,t) = s1(t+1,t) + (rho-1)*Ds(t+1,t) 
%          = 1/2e(t+1)'*Theta0rho*e(t+1)+e(t+1)'*Theta1rho*x(t)+msrho+Usrho*x(t)+kesi0rho*e(t+1)
% Ds1(t+1,t) = 1/2e(t+1)'*Theta0*e(t+1)+e(t+1)'*Theta1*x(t)+theta0+theta1*x(t)+theta2*e(t+1)
% s1(t+1,t)  = ms + Us*x(t) + kesi0*e(t+1)

function [Theta0rho Theta1rho msrho Usrho kesi0rho] = SDF(Theta0, Theta1, theta0, theta1, theta2, ms, Us, kesi0, rho)
Theta0rho = (rho-1)*Theta0;
Theta1rho = (rho-1)*Theta1;
msrho = ms + (rho-1)*theta0;
Usrho = Us + (rho-1)*theta1;
kesi0rho = kesi0 + (rho-1)*theta2;