% This function gives the solution of SDF with recursive utility, rho = 1 
% and linear dynamics of consumption as
% x(t) = G*x(t-1)+H*w(t), wt follow std norm dist.
% c(t+1)-c(t) = mc + Uc*x(t)+lambda0*w(t+1)
% lambdab is the discounted response of consumption to shocks
% lambdab = lambda0+beta*Uc*inv(I-G)*H
% It gives s(t+1,t) = ms + Us*x(t) + kesi0*w(t+1) 
function [ms Us kesi0] = SDF1(G, H, mc, Uc, lambda0, beta, gamma)
lambdab = lambda0 + beta*Uc*inv(eye(size(G))-beta*G)*H;
ms     = log(beta) - mc - (1-gamma)^2*(lambdab*lambdab')/2;
Us     = -Uc;
kesi0  = -lambda0 + (1-gamma)*lambdab;